KBDCONTROL(1)

NAME
kbdcontrol - keyboard control and configuration utility

SYNOPSIS
kbdcontrol [-dFKix] [-A name] [-a name] [ -b duration.pitch | belltype] [ -r delay.repeat | speed] [-l keymap_file] [-f # string] [-k keyboard_device] [-L keymap_file]

DESCRIPTION
The kbdcontrol command is used to set various keyboard related options for the syscons(4) console driver and the keyboard drivers, such as key map, keyboard repeat and delay rates, bell characteristics etc.

Keyboard options may be automatically configured at system boot time by setting variables in /etc/rc.conf. See Boot Time Configuration below.

The following command line options are supported:

-A name
    Detach the keyboard, specified by the keyboard device name, from the keyboard multiplexer. When using this option, the standard input of the kbdcontrol process should be redirected from the keyboard multiplexer keyboard device (if the keyboard multiplexer is not the active keyboard) or /dev/console (if the keyboard multiplexer is the active keyboard and you are not working on the system console).

-a name
    Attach the keyboard, specified by the keyboard device name, to the keyboard multiplexer. When using this option, the standard input of the kbdcontrol process should be redirected from the keyboard multiplexer keyboard device (if the keyboard multiplexer is not the active keyboard) or /dev/console (if the keyboard multiplexer is the active keyboard and you are not working on the system console).

-b  duration.pitch | belltype Set the bell duration in milliseconds and pitch in hertz. If a belltype argument is specified, it may be one of normal which sets sound parameters back to normal values, off which disables the bell entirely, or visual which sets the bell to visual mode, i.e., flashes the screen instead. If belltype is preceded by the word quiet., the bell will not be rung when the ringing process is in the background vty. The visual bell, when chosen, applies to all vtys; other bell types can be set individually for each vty.

-r  delay.repeat | speed Set keyboard delay (250, 500, 750, 1000) and repeat (34, 38, 42, 46, 50, 55, 59, 63, 68, 76, 84, 92, 100, 110, 118, 126, 136, 152, 168, 184, 200, 220, 236, 252, 272, 304, 336, 368, 400, 440, 472, 504) rates, or if a speed argument is specified, it may be one of slow (1000.504), fast (250.34) or normal (500.126).

-l keymap_file
    Install keyboard map file from keymap_file. You may load the keyboard map file from a menu-driven command, kbdmap(1). The format of keyboard map files is documented in the kbdmap(5) manual page.

-d  Dump the current keyboard map onto stdout. The output may be redirected to a file and can be loaded back to the kernel later by the -l option above.

-f # string
    Set function key number # to send string. Refer to the man page for the keyboard driver (e.g. atkbd(4)) for available function keys and their numbers.

-F  Set function keys back to the standard definitions.

-x  Use hexadecimal numbers in keyboard map dump.

-i  Print brief information about the keyboard.

-K  Disconnect the keyboard from the console. You need to use the -k option below to associate a keyboard with the console again.

-k keyboard_device
    Use the specified device as the console keyboard. When using this option, the standard input of the kbdcontrol process should be redirected from /dev/console if you are not working on the system console (see the EXAMPLES section).

-L keymap_file
    Load keyboard map file from keymap_file and write the struct keymap compiled from it to stdout. This option is primarily intended for programmers and is probably of little use under normal circumstances.

ENVIRONMENT
The environment variable KEYMAP_PATH can hold an alternative path to the keyboard map files.

KEYBOARD CONFIGURATION

  Boot Time Configuration
You may set variables in /etc/rc.conf or /etc/rc.conf.local in order to configure the keyboard at boot time. The following is the list of relevant variables.

keymap
    Specifies a keyboard map file for the -l option.
keyrate
    Sets the keyboard repeat rate for the -r option.
keychange
    Lists function key strings for the -f option.

See rc.conf(5) for details.

  Driver Configuration
The keyboard device driver may let you change default configuration options, such as the default keyboard map, so that you do not need to set up the options at boot time. See keyboard driver manuals (e.g. atkbd(4), ukbd(4)) for details.

FILES
/usr/share/syscons/keymaps/*
    keyboard map files

EXAMPLES
The following command will load the keyboard map file /usr/share/syscons/keymaps/ru.koi8-r.kbd.

    kbdcontrol -l /usr/share/syscons/keymaps/ru.koi8-r.kbd

So long as the keyboard map file resides in /usr/share/syscons/keymaps, you may abbreviate the file name as ru.koi8-r.

    kbdcontrol -l ru.koi8-r

The following command will make the function key 10 emit "telnet myhost".

    kbdcontrol -f 10 "telnet myhost"

In order to get the visual effect for bell, but prevent the screen from flashing if the bell is to ring in the background screen, run the following command.

    kbdcontrol -b quiet.visual

To change the default console keyboard to another keyboard, for example the first USB keyboard (see ukbd(4)), use the following command.

    kbdcontrol -k /dev/ukbd0 < /dev/console

To switch back to the default keyboard, use this command.

    kbdcontrol -k /dev/kbd0

To allow using both the second USB keyboard and the first AT keyboard at the same time on console via the kbdmux(4) driver, use the following sequence of commands.

    kbdcontrol -K < /dev/console
    kbdcontrol -a atkbd0 < /dev/kbdmux0
    kbdcontrol -a ukbd1 < /dev/kbdmux0
    kbdcontrol -k /dev/kbdmux0 < /dev/console

SEE ALSO
kbdmap(1), vidcontrol(1), atkbd(4), kbdmux(4), keyboard(4), screen(4), syscons(4), ukbd(4), kbdmap(5), rc.conf(5)

AUTHORS
Søren Schmidt <sos@FreeBSD.org>

BUGS
Report when found.